traffic-light-arduino-uno
=========================

This is a simple traffic light in Rust for the _Arduino Uno_.

Without interaction, it stays red. After pressing the button, first the yellow LED is turned on and after a second the
green LED.
A green phase lasts for 10 seconds, after which the yellow LED is turned on again. After two seconds the traffic light
switches back to red.

## Build Instructions

1. Install prerequisites as described in the [`avr-hal` README] (`avr-gcc`, `avr-libc`, `avrdude`, [`ravedude`]).

2. Run `cargo build` to build the firmware.

3. Run `cargo run` to flash the firmware to a connected board. If `ravedude`
   fails to detect your board, check its documentation at
   <https://crates.io/crates/ravedude>.

4. `ravedude` will open a console session after flashing where you can interact
   with the UART console of your board.

[`avr-hal` README]: https://github.com/Rahix/avr-hal#readme

[`ravedude`]: https://crates.io/crates/ravedude

## License

MIT license ([LICENSE-MIT](LICENSE-MIT) or <http://opensource.org/licenses/MIT>)
