#![no_std]
#![no_main]

use arduino_hal::delay_ms;
use panic_halt as _;

#[arduino_hal::entry]
fn main() -> ! {
    let dp = arduino_hal::Peripherals::take().unwrap();
    let pins = arduino_hal::pins!(dp);

    // for some reason without this the builtin LED would always turn on/off together with the red LED.
    let mut builtin_led = pins.d13.into_output();
    builtin_led.set_low();

    let mut red_led = pins.d12.into_output();
    let mut yellow_led = pins.d8.into_output();
    let mut green_led = pins.d7.into_output();

    let button = pins.d2.into_pull_up_input();

    red_led.set_high();
    yellow_led.set_low();
    green_led.set_low();

    loop {
        if button.is_high() {
            // signal coming
            yellow_led.set_high();
            delay_ms(1000);
            // green
            red_led.set_low();
            yellow_led.set_low();
            green_led.set_high();
            delay_ms(10_000);
            // signal leaving
            green_led.set_low();
            yellow_led.set_high();
            delay_ms(2000);
            // red
            yellow_led.set_low();
            red_led.set_high();
        }
    }
}
